MiniConQueryRewriter.MiniConDescription
Keywords: uk.ac.ic.doc.rodex.qproc.MiniConQueryRewriter.MiniConDescription class

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## uk.ac.ic.doc.rodex.qproc
Class MiniConQueryRewriter.MiniConDescription

    java.lang.Object
      uk.ac.ic.doc.rodex.qproc.MiniConQueryRewriter.MiniConDescription

Enclosing class:
  MiniConQueryRewriter

    protected class MiniConQueryRewriter.MiniConDescription

extends java.lang.Object

A private inner class to represent an MCD

Constructor Summary
`MiniConQueryRewriter.MiniConDescription(QueryAnalyser view)`

Method Summary
`java.util.List` | `add(MiniConQueryRewriter.MiniConDescription anotherMCD)` A method to add two MCD objects together.
`void` | `addASubGoal(QuerySubGoal qsg)` Add a sub-goal to this MCD
`void` | `addSubGoals(java.util.List subGoals)` Add sub-goals to the MCD
`java.util.List` | `getConstantVariables()` Return a `List` of constants (if any) in the associated view
`java.util.List` | `getFunctions()` Return the `List` of `QueryFunction` objects found. Returns `null` if no functions found
`java.util.List` | `getHeadVars()` Return a `List` of head variables of the view query associated to this `MCD`
`java.util.List` | `getSubGoals()` Returns only the minimum set of sub-goals found when constructing the MCD
`ASG` | `getView()` Return the original ASG object of the view
`java.lang.String` | `getViewAsString()` Return the view rule to which this MCD is associated
`java.util.List` | `getViewSubGoals()` Returns the complete set of sub-goals of the associated view
`boolean` | `isDisjointWith(MiniConQueryRewriter.MiniConDescription anotherMCD)` Check if this MCD is disjoint from another MCD, i.e.
`java.lang.String` | `toString()` Convert MCD's content to string

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### MiniConQueryRewriter.MiniConDescription

    public MiniConQueryRewriter.MiniConDescription(QueryAnalyser view)

Method Detail

### addASubGoal

    public void addASubGoal(QuerySubGoal qsg)

  Add a sub-goal to this MCD

  Parameters:
    `qsg` - a `QuerySubGoal` object

### addSubGoals

    public void addSubGoals(java.util.List subGoals)

  Add sub-goals to the MCD

  Parameters:
    `List` - sub goals that form the MCD

### getSubGoals

    public java.util.List getSubGoals()

  Returns only the minimum set of sub-goals found when constructing the MCD

  Returns:
    `List` a list of `QuerySubGoal` objects

### getViewSubGoals

    public java.util.List getViewSubGoals()

  Returns the complete set of sub-goals of the associated view

  Returns:
    `List` a list of `QuerySubGoal` objects

### isDisjointWith

    public boolean isDisjointWith(MiniConQueryRewriter.MiniConDescription anotherMCD)

  Check if this MCD is disjoint from another MCD, i.e. sharing no common sub-goals

  Parameters:
    `anotherMCD` - another `MiniConQueryRewriter.MiniConDescription` object
  Returns:
    boolean true if disjoint, false otherwise

### add

    public java.util.List add(MiniConQueryRewriter.MiniConDescription anotherMCD)

  A method to add two MCD objects together. This operation involves
  adding two sets of sub-goals of the two MCDs

  Parameters:
    `anotherMCD` - the second `MiniConQueryRewriter.MiniConDescription` object
  Returns:
    `List` a combined list of sub-goals from the two MCDs

### getViewAsString

    public java.lang.String getViewAsString()

  Return the view rule to which this MCD is associated

  Returns:
    String the view rule

### getView

    public ASG getView()

  Return the original ASG object of the view

### getConstantVariables

    public java.util.List getConstantVariables()

  Return a `List` of constants (if any) in the associated view

  Returns:
    List list of constants or `null` if no constants are found

### getHeadVars

    public java.util.List getHeadVars()

  Return a `List` of head variables of the view query associated
  to this `MCD`

### getFunctions

    public java.util.List getFunctions()

  Return the `List` of `QueryFunction` objects found.
  Returns `null` if no functions found

### toString

    public java.lang.String toString()

  Convert MCD's content to string

  Overrides:
    `toString` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD